// Autogenerated from Pigeon (v4.1.0), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import "Native.h"
#import <Flutter/Flutter.h>

#if !__has_feature(objc_arc)
#error File requires ARC to be enabled.
#endif

static NSDictionary<NSString *, id> *wrapResult(id result, FlutterError *error) {
  NSDictionary *errorDict = (NSDictionary *)[NSNull null];
  if (error) {
    errorDict = @{
        @"code": (error.code ?: [NSNull null]),
        @"message": (error.message ?: [NSNull null]),
        @"details": (error.details ?: [NSNull null]),
        };
  }
  return @{
      @"result": (result ?: [NSNull null]),
      @"error": errorDict,
      };
}
static id GetNullableObject(NSDictionary* dict, id key) {
  id result = dict[key];
  return (result == [NSNull null]) ? nil : result;
}
static id GetNullableObjectAtIndex(NSArray* array, NSInteger key) {
  id result = array[key];
  return (result == [NSNull null]) ? nil : result;
}


@interface NativeError ()
+ (NativeError *)fromMap:(NSDictionary *)dict;
+ (nullable NativeError *)nullableFromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface NativeImpression ()
+ (NativeImpression *)fromMap:(NSDictionary *)dict;
+ (nullable NativeImpression *)nullableFromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end

@implementation NativeError
+ (instancetype)makeWithCode:(NSNumber *)code
    description:(NSString *)description {
  NativeError* pigeonResult = [[NativeError alloc] init];
  pigeonResult.code = code;
  pigeonResult.description = description;
  return pigeonResult;
}
+ (NativeError *)fromMap:(NSDictionary *)dict {
  NativeError *pigeonResult = [[NativeError alloc] init];
  pigeonResult.code = GetNullableObject(dict, @"code");
  NSAssert(pigeonResult.code != nil, @"");
  pigeonResult.description = GetNullableObject(dict, @"description");
  NSAssert(pigeonResult.description != nil, @"");
  return pigeonResult;
}
+ (nullable NativeError *)nullableFromMap:(NSDictionary *)dict { return (dict) ? [NativeError fromMap:dict] : nil; }
- (NSDictionary *)toMap {
  return @{
    @"code" : (self.code ?: [NSNull null]),
    @"description" : (self.description ?: [NSNull null]),
  };
}
@end

@implementation NativeImpression
+ (instancetype)makeWithData:(NSString *)data {
  NativeImpression* pigeonResult = [[NativeImpression alloc] init];
  pigeonResult.data = data;
  return pigeonResult;
}
+ (NativeImpression *)fromMap:(NSDictionary *)dict {
  NativeImpression *pigeonResult = [[NativeImpression alloc] init];
  pigeonResult.data = GetNullableObject(dict, @"data");
  NSAssert(pigeonResult.data != nil, @"");
  return pigeonResult;
}
+ (nullable NativeImpression *)nullableFromMap:(NSDictionary *)dict { return (dict) ? [NativeImpression fromMap:dict] : nil; }
- (NSDictionary *)toMap {
  return @{
    @"data" : (self.data ?: [NSNull null]),
  };
}
@end

@interface YandexAdsNativeCodecReader : FlutterStandardReader
@end
@implementation YandexAdsNativeCodecReader
- (nullable id)readValueOfType:(UInt8)type 
{
  switch (type) {
    case 128:     
      return [NativeError fromMap:[self readValue]];
    
    case 129:     
      return [NativeImpression fromMap:[self readValue]];
    
    default:    
      return [super readValueOfType:type];
    
  }
}
@end

@interface YandexAdsNativeCodecWriter : FlutterStandardWriter
@end
@implementation YandexAdsNativeCodecWriter
- (void)writeValue:(id)value 
{
  if ([value isKindOfClass:[NativeError class]]) {
    [self writeByte:128];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[NativeImpression class]]) {
    [self writeByte:129];
    [self writeValue:[value toMap]];
  } else 
{
    [super writeValue:value];
  }
}
@end

@interface YandexAdsNativeCodecReaderWriter : FlutterStandardReaderWriter
@end
@implementation YandexAdsNativeCodecReaderWriter
- (FlutterStandardWriter *)writerWithData:(NSMutableData *)data {
  return [[YandexAdsNativeCodecWriter alloc] initWithData:data];
}
- (FlutterStandardReader *)readerWithData:(NSData *)data {
  return [[YandexAdsNativeCodecReader alloc] initWithData:data];
}
@end

NSObject<FlutterMessageCodec> *YandexAdsNativeGetCodec() {
  static dispatch_once_t sPred = 0;
  static FlutterStandardMessageCodec *sSharedObject = nil;
  dispatch_once(&sPred, ^{
    YandexAdsNativeCodecReaderWriter *readerWriter = [[YandexAdsNativeCodecReaderWriter alloc] init];
    sSharedObject = [FlutterStandardMessageCodec codecWithReaderWriter:readerWriter];
  });
  return sSharedObject;
}


void YandexAdsNativeSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<YandexAdsNative> *api) {
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsNative.make"
        binaryMessenger:binaryMessenger
        codec:YandexAdsNativeGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(makeId:error:)], @"YandexAdsNative api (%@) doesn't respond to @selector(makeId:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api makeId:arg_id error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsNative.load"
        binaryMessenger:binaryMessenger
        codec:YandexAdsNativeGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loadId:width:height:error:)], @"YandexAdsNative api (%@) doesn't respond to @selector(loadId:width:height:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        NSNumber *arg_width = GetNullableObjectAtIndex(args, 1);
        NSNumber *arg_height = GetNullableObjectAtIndex(args, 2);
        FlutterError *error;
        [api loadId:arg_id width:arg_width height:arg_height error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsNative.onAdLoaded"
        binaryMessenger:binaryMessenger
        codec:YandexAdsNativeGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onAdLoadedId:completion:)], @"YandexAdsNative api (%@) doesn't respond to @selector(onAdLoadedId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onAdLoadedId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsNative.onAdFailedToLoad"
        binaryMessenger:binaryMessenger
        codec:YandexAdsNativeGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onAdFailedToLoadId:completion:)], @"YandexAdsNative api (%@) doesn't respond to @selector(onAdFailedToLoadId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onAdFailedToLoadId:arg_id completion:^(NativeError *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsNative.onAdClicked"
        binaryMessenger:binaryMessenger
        codec:YandexAdsNativeGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onAdClickedId:completion:)], @"YandexAdsNative api (%@) doesn't respond to @selector(onAdClickedId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onAdClickedId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsNative.onLeftApplication"
        binaryMessenger:binaryMessenger
        codec:YandexAdsNativeGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onLeftApplicationId:completion:)], @"YandexAdsNative api (%@) doesn't respond to @selector(onLeftApplicationId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onLeftApplicationId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsNative.onReturnedToApplication"
        binaryMessenger:binaryMessenger
        codec:YandexAdsNativeGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onReturnedToApplicationId:completion:)], @"YandexAdsNative api (%@) doesn't respond to @selector(onReturnedToApplicationId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onReturnedToApplicationId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsNative.onImpression"
        binaryMessenger:binaryMessenger
        codec:YandexAdsNativeGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onImpressionId:completion:)], @"YandexAdsNative api (%@) doesn't respond to @selector(onImpressionId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onImpressionId:arg_id completion:^(NativeImpression *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
}
