// Autogenerated from Pigeon (v4.1.0), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import "Rewarded.h"
#import <Flutter/Flutter.h>

#if !__has_feature(objc_arc)
#error File requires ARC to be enabled.
#endif

static NSDictionary<NSString *, id> *wrapResult(id result, FlutterError *error) {
  NSDictionary *errorDict = (NSDictionary *)[NSNull null];
  if (error) {
    errorDict = @{
        @"code": (error.code ?: [NSNull null]),
        @"message": (error.message ?: [NSNull null]),
        @"details": (error.details ?: [NSNull null]),
        };
  }
  return @{
      @"result": (result ?: [NSNull null]),
      @"error": errorDict,
      };
}
static id GetNullableObject(NSDictionary* dict, id key) {
  id result = dict[key];
  return (result == [NSNull null]) ? nil : result;
}
static id GetNullableObjectAtIndex(NSArray* array, NSInteger key) {
  id result = array[key];
  return (result == [NSNull null]) ? nil : result;
}


@interface RewardedError ()
+ (RewardedError *)fromMap:(NSDictionary *)dict;
+ (nullable RewardedError *)nullableFromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface RewardedImpression ()
+ (RewardedImpression *)fromMap:(NSDictionary *)dict;
+ (nullable RewardedImpression *)nullableFromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end
@interface RewardedEvent ()
+ (RewardedEvent *)fromMap:(NSDictionary *)dict;
+ (nullable RewardedEvent *)nullableFromMap:(NSDictionary *)dict;
- (NSDictionary *)toMap;
@end

@implementation RewardedError
+ (instancetype)makeWithCode:(NSNumber *)code
    description:(NSString *)description {
  RewardedError* pigeonResult = [[RewardedError alloc] init];
  pigeonResult.code = code;
  pigeonResult.description = description;
  return pigeonResult;
}
+ (RewardedError *)fromMap:(NSDictionary *)dict {
  RewardedError *pigeonResult = [[RewardedError alloc] init];
  pigeonResult.code = GetNullableObject(dict, @"code");
  NSAssert(pigeonResult.code != nil, @"");
  pigeonResult.description = GetNullableObject(dict, @"description");
  NSAssert(pigeonResult.description != nil, @"");
  return pigeonResult;
}
+ (nullable RewardedError *)nullableFromMap:(NSDictionary *)dict { return (dict) ? [RewardedError fromMap:dict] : nil; }
- (NSDictionary *)toMap {
  return @{
    @"code" : (self.code ?: [NSNull null]),
    @"description" : (self.description ?: [NSNull null]),
  };
}
@end

@implementation RewardedImpression
+ (instancetype)makeWithData:(NSString *)data {
  RewardedImpression* pigeonResult = [[RewardedImpression alloc] init];
  pigeonResult.data = data;
  return pigeonResult;
}
+ (RewardedImpression *)fromMap:(NSDictionary *)dict {
  RewardedImpression *pigeonResult = [[RewardedImpression alloc] init];
  pigeonResult.data = GetNullableObject(dict, @"data");
  NSAssert(pigeonResult.data != nil, @"");
  return pigeonResult;
}
+ (nullable RewardedImpression *)nullableFromMap:(NSDictionary *)dict { return (dict) ? [RewardedImpression fromMap:dict] : nil; }
- (NSDictionary *)toMap {
  return @{
    @"data" : (self.data ?: [NSNull null]),
  };
}
@end

@implementation RewardedEvent
+ (instancetype)makeWithAmount:(NSNumber *)amount
    type:(NSString *)type {
  RewardedEvent* pigeonResult = [[RewardedEvent alloc] init];
  pigeonResult.amount = amount;
  pigeonResult.type = type;
  return pigeonResult;
}
+ (RewardedEvent *)fromMap:(NSDictionary *)dict {
  RewardedEvent *pigeonResult = [[RewardedEvent alloc] init];
  pigeonResult.amount = GetNullableObject(dict, @"amount");
  NSAssert(pigeonResult.amount != nil, @"");
  pigeonResult.type = GetNullableObject(dict, @"type");
  NSAssert(pigeonResult.type != nil, @"");
  return pigeonResult;
}
+ (nullable RewardedEvent *)nullableFromMap:(NSDictionary *)dict { return (dict) ? [RewardedEvent fromMap:dict] : nil; }
- (NSDictionary *)toMap {
  return @{
    @"amount" : (self.amount ?: [NSNull null]),
    @"type" : (self.type ?: [NSNull null]),
  };
}
@end

@interface YandexAdsRewardedCodecReader : FlutterStandardReader
@end
@implementation YandexAdsRewardedCodecReader
- (nullable id)readValueOfType:(UInt8)type 
{
  switch (type) {
    case 128:     
      return [RewardedError fromMap:[self readValue]];
    
    case 129:     
      return [RewardedEvent fromMap:[self readValue]];
    
    case 130:     
      return [RewardedImpression fromMap:[self readValue]];
    
    default:    
      return [super readValueOfType:type];
    
  }
}
@end

@interface YandexAdsRewardedCodecWriter : FlutterStandardWriter
@end
@implementation YandexAdsRewardedCodecWriter
- (void)writeValue:(id)value 
{
  if ([value isKindOfClass:[RewardedError class]]) {
    [self writeByte:128];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[RewardedEvent class]]) {
    [self writeByte:129];
    [self writeValue:[value toMap]];
  } else 
  if ([value isKindOfClass:[RewardedImpression class]]) {
    [self writeByte:130];
    [self writeValue:[value toMap]];
  } else 
{
    [super writeValue:value];
  }
}
@end

@interface YandexAdsRewardedCodecReaderWriter : FlutterStandardReaderWriter
@end
@implementation YandexAdsRewardedCodecReaderWriter
- (FlutterStandardWriter *)writerWithData:(NSMutableData *)data {
  return [[YandexAdsRewardedCodecWriter alloc] initWithData:data];
}
- (FlutterStandardReader *)readerWithData:(NSData *)data {
  return [[YandexAdsRewardedCodecReader alloc] initWithData:data];
}
@end

NSObject<FlutterMessageCodec> *YandexAdsRewardedGetCodec() {
  static dispatch_once_t sPred = 0;
  static FlutterStandardMessageCodec *sSharedObject = nil;
  dispatch_once(&sPred, ^{
    YandexAdsRewardedCodecReaderWriter *readerWriter = [[YandexAdsRewardedCodecReaderWriter alloc] init];
    sSharedObject = [FlutterStandardMessageCodec codecWithReaderWriter:readerWriter];
  });
  return sSharedObject;
}


void YandexAdsRewardedSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<YandexAdsRewarded> *api) {
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.make"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(makeId:error:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(makeId:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api makeId:arg_id error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.load"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(loadId:error:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(loadId:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api loadId:arg_id error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.show"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(showId:error:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(showId:error:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        FlutterError *error;
        [api showId:arg_id error:&error];
        callback(wrapResult(nil, error));
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onAdLoaded"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onAdLoadedId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onAdLoadedId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onAdLoadedId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onAdFailedToLoad"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onAdFailedToLoadId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onAdFailedToLoadId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onAdFailedToLoadId:arg_id completion:^(RewardedError *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onAdShown"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onAdShownId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onAdShownId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onAdShownId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onAdDismissed"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onAdDismissedId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onAdDismissedId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onAdDismissedId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onAdClicked"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onAdClickedId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onAdClickedId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onAdClickedId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onLeftApplication"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onLeftApplicationId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onLeftApplicationId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onLeftApplicationId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onReturnedToApplication"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onReturnedToApplicationId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onReturnedToApplicationId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onReturnedToApplicationId:arg_id completion:^(FlutterError *_Nullable error) {
          callback(wrapResult(nil, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onImpression"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onImpressionId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onImpressionId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onImpressionId:arg_id completion:^(RewardedImpression *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
  {
    FlutterBasicMessageChannel *channel =
      [[FlutterBasicMessageChannel alloc]
        initWithName:@"dev.flutter.pigeon.YandexAdsRewarded.onRewarded"
        binaryMessenger:binaryMessenger
        codec:YandexAdsRewardedGetCodec()        ];
    if (api) {
      NSCAssert([api respondsToSelector:@selector(onRewardedId:completion:)], @"YandexAdsRewarded api (%@) doesn't respond to @selector(onRewardedId:completion:)", api);
      [channel setMessageHandler:^(id _Nullable message, FlutterReply callback) {
        NSArray *args = message;
        NSString *arg_id = GetNullableObjectAtIndex(args, 0);
        [api onRewardedId:arg_id completion:^(RewardedEvent *_Nullable output, FlutterError *_Nullable error) {
          callback(wrapResult(output, error));
        }];
      }];
    }
    else {
      [channel setMessageHandler:nil];
    }
  }
}
